package com.backend.glowhouse.controller;

import com.backend.glowhouse.model.Device;
import com.backend.glowhouse.model.request.DeviceRegistrationRequest;
import com.backend.glowhouse.model.response.ApiResponse;
import com.backend.glowhouse.model.response.DeviceIdResponse;
import com.backend.glowhouse.model.response.DeviceRegistrationResponse;
import com.backend.glowhouse.repository.device.DeviceRepository;
import com.backend.glowhouse.repository.user.UserRepository;
import com.backend.glowhouse.service.DeviceService;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api/device")
public class DeviceController {
    @Autowired
    private DeviceService deviceService;

    @PostMapping("/registerDevice")
    @PreAuthorize("hasRole('USER')")
    public String registerDevice(@RequestBody DeviceRegistrationRequest deviceRegistrationRequest) throws JsonProcessingException {
        return deviceService.handleDeviceRegistration(deviceRegistrationRequest);
    }

    @GetMapping("/getDeviceIdForUser")
    public String getDeviceIdForUser(@RequestParam(value = "username") String username) throws JsonProcessingException {
        if (username != null) {
            return deviceService.getDeviceIdForUser(username);
        } else {
            return null;
        }
    }
}
