package com.backend.glowhouse.controller;

import com.amazonaws.services.iot.client.AWSIotException;
import com.backend.glowhouse.model.request.ShadowUpdateRequest;
import com.backend.glowhouse.service.DeviceShadowService;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/api/shadow")
public class DeviceShadowController {
    @Autowired
    private DeviceShadowService deviceShadowService;

    @PostMapping
    @RequestMapping(method = POST, path = "/update")
    public HttpStatus updateShadow(@RequestBody ShadowUpdateRequest updateRequest) throws JsonProcessingException, AWSIotException {
        return deviceShadowService.handleShadowUpdateRequest(updateRequest);
    }

    @GetMapping("/get")
    public String getDeviceShadow(@RequestParam(value = "deviceId") String deviceId) throws AWSIotException {
        return deviceShadowService.handleShadowGetRequest(deviceId);
    }
}
