package com.backend.glowhouse.repository.device;

import com.backend.glowhouse.model.Device;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;


public class DeviceRepositoryImpl implements DeviceRepositoryCustom {
    private final MongoTemplate mongoTemplate;

    @Autowired
    public  DeviceRepositoryImpl(MongoTemplate mongoTemplate) {
        this.mongoTemplate = mongoTemplate;
    }

    @Override
    //Method for updating device document when registered
    //Returns
    public Device registerUserToDevice(String deviceId, String username) {
        //Query for existing device
        Query query = new Query();
        query.addCriteria(Criteria.where("deviceId").is(deviceId));

        Device device = mongoTemplate.findOne(query, Device.class);

        //If a device is found
        if (device != null) {
            //Update to make on device returned by query
            Update update = new Update()
                    .set("registeredUser", username)
                    .set("registered", true);

            //Execute update
            mongoTemplate.updateFirst(query, update, Device.class);

            //Return updated device for assignment to User doument
            return mongoTemplate.findOne(query, Device.class);
        }

        //Return null if device doesn't exist
        return null;
    }
}
