package com.backend.glowhouse.repository.user;

import com.backend.glowhouse.model.Device;
import com.backend.glowhouse.model.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.core.query.Update;


public class UserRepositoryImpl implements UserRepositoryCustom{
    private final MongoTemplate mongoTemplate;

    @Autowired
    public  UserRepositoryImpl(MongoTemplate mongoTemplate) {
        this.mongoTemplate = mongoTemplate;
    }

    @Override
    public boolean registerDeviceToUser(String username, Device device) {
        Query query = new Query();
        query.addCriteria(Criteria.where("username").is(username));

        Update update = new Update()
                .set("device", device);

        mongoTemplate.updateFirst(query, update, User.class);

        return true;
    }
}
