package com.backend.glowhouse;

import com.backend.glowhouse.controller.DeviceController;
import com.backend.glowhouse.model.SensorData;
import com.backend.glowhouse.repository.data.SensorDataRepository;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Random;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = {GlowhouseApplication.class, DeviceController.class})
public class TestDataPersistence {
    @Autowired
    private SensorDataRepository sensorDataRepository;

    @Test
    public void createDummySensorData() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");

        String startDate = "04/23/2019 00:00:00";
        String endDate = "05/23/2019 23:59:59";

        Date startDateTime = sdf.parse(startDate);
        Date endDateTime = sdf.parse(endDate);

        long diff = endDateTime.getTime() - startDateTime.getTime();
        long minutes = diff / (60 * 1000) % 60;

        List<SensorData> sensorDataList = new ArrayList<>();
        Date currentDate = startDateTime;

        for (long i = 0; i < minutes; i++) {
            SensorData dataObject = new SensorData();

            Random t = new Random();
            Random h = new Random();
            Random p = new Random();

            int temp = t.nextInt(5 + 1) + 20;
            int humidity = h.nextInt(25 + 1) + 40;
            int ph = p.nextInt(2 + 1) + 5;

            dataObject.setdId("glowhouse-001");
            dataObject.setDate(currentDate);
            dataObject.setT(temp);
            dataObject.setH(humidity);
            dataObject.setPh(ph);

            sensorDataList.add(dataObject);

            long time = currentDate.getTime();
            Date nextDate = new Date(time + 60000);
            currentDate = nextDate;
        }

        sensorDataRepository.saveAll(sensorDataList);
        //TODO: add count check here between dates
        //currently this needs to then be checked manually in the database after the test has been run
    }
}
